function DebugLoggerLog(){
	this.level = 3;
	this.message;
	this.logger;
	this.timestamp;
	
	/**
	* Initialize this log object
	* @param int level Level of debug message (1=most granular, 5=most broad)
	* @param string message
	* @param nsIDebugLogger logger Logger object this belongs to
	*/
	this.init = function(level, message, logger){
		this.level = level;
		this.message = message;
		this.logger = logger;
		this.timestamp = (new Date()).getTime();
	}
}

DebugLoggerLog.prototype = {
	QueryInterface: function (iid) {
		if(!iid.equals(Components.interfaces.nsIDebugLoggerLog) && !iid.equals(Components.interfaces.nsISupports))
			throw Components.results.NS_ERROR_NO_INTERFACE;
		
		return this;
	}
};
var Module = {
	myCID : Components.ID("{37F5BBA2-B980-4313-9689-5C8D02389A0E}"),
    myProgID : "@mozmonkey.com/debuglogger/log;1",
    firstTime : true,
	registerSelf : function (compMgr, fileSpec, location, type) {
		if(this.firstTime) {
			this.firstTime = false;
			throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
		}
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(this.myCID, "Debug Logger Log", this.myProgID, fileSpec, location, type);
	},
	getClassObject : function (compMgr, cid, iid) {
		if (!cid.equals(this.myCID)) throw Components.results.NS_ERROR_NO_INTERFACE;
		if (!iid.equals(Components.interfaces.nsIFactory)) throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		return this.myFactory;
	},
    myFactory : {
		createInstance : function (outer, iid) {
			if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
			return (new DebugLoggerLog()).QueryInterface(iid);
		}
	},
    canUnload : function(compMgr) { return true; }
};
function NSGetModule(compMgr, fileSpec) { return Module; }